function [s1_opt]= Quasi_Newton (s0, fi, invQ, rnkQ) 


MaxIter = 1;

discount = 0.618;

%   Variable Declaration 
 si        = zeros(size(s0,1),MaxIter+1);
 si(:,1)   = s0;
 
%  Bi = invQ; % eye(size(s0,1)); % Hessian
 Hi = inv(invQ);
 
for i = 1:MaxIter
 
      %Calculate Gradient around current point
      if i == 1
          [Jcost, GradJ] =  costFun (si(:,i), fi, invQ);
      else
          Jcost = Jcost_Next;
          GradJ = GradJ_Next;
      end
      
      if isnan(Jcost)
          Jcost = Inf;
      end
        
%  
      %Calculate search direction 
%       di             = -Bi\GradJ ;
      di             = -Hi*GradJ ;

      step = 0.618; % re-assign step
      s1_temp = si(:,i) + step*di;
      
      [Jcost_Next, GradJ_Next] = costFun(s1_temp,fi,invQ);
      
      if Jcost_Next >= Jcost
          while  Jcost_Next >= Jcost
              step = step * discount;
              s1_temp = si(:,i) + step*discount*di;
              Jcost_Next = costFun(s1_temp,fi,invQ);       

              if abs(Jcost_Next-Jcost) < 0.001
    %               [Jcost_Next GradJ_Next] = costFun(s1_temp,fi,rnkQ,invQ1);
                  break;
              end
          end
          [Jcost_Next, GradJ_Next] = costFun(s1_temp,fi,invQ);
      end
      

        
      %Calculate Next solution of X    
      si(:,i+1)      =  s1_temp;
 
      %Calculate new Beta value using BFGS algorithm            
%       Bi                =  BFGS(GradJ,GradJ_Next,si(:,i+1),si(:,i), Bi);         
      Hi                =  invBFGS(GradJ,GradJ_Next,si(:,i+1),si(:,i), Hi);         

end
  % report optimum solution
   s1_opt    = si(:,i+1);

 
end
 
%***********************************************************************%
% Broyden, Fletcher, Goldfarb and Shanno (BFGS) formula
%***********************************************************************%
% function  B  = BFGS(GradOfU,Grad_Next,Xi_next,Xi,Bi)
%  
%  % Calculate Si term
%   si               =  Xi_next   - Xi;
%  
%  % Calculate Yi term
%   yi               =  Grad_Next - GradOfU;
%  %
%  % BFGS formula (Broyden, Fletcher, Goldfarb and Shanno)
%  %
%   B   =  Bi - ((Bi*si)*(Bi*si)'/(si'*Bi*si)) + ((yi*yi')/(yi'*si));
%  
% end

function  H  = invBFGS(GradOfU,Grad_Next,Xi_next,Xi,Hi)
 
 % Calculate Si term
  si               =  Xi_next   - Xi;
 
 % Calculate Yi term
  yi               =  Grad_Next - GradOfU;
 %
 % BFGS formula (Broyden, Fletcher, Goldfarb and Shanno)
 %
  
  H = (eye(size(Hi)) - (yi*si')/(yi'*si))' * Hi * (eye(size(Hi)) - (yi*si')/(yi'*si)) + si*si'/(yi'*si);
 
end



function [J, gradJ] = costFun(s1,fi,invQ)
% global T;
% global Q;
% global R;
global sigbound;
global sigvel;


p3 = 5e-5; 
p2 = -0.004;
p1 = -0.2;
p0 = 125;

J0 = 0.5*(s1 - fi)'*invQ*(s1 - fi);


gVal = gCon(s1);

g1 = gVal(1);
g2 = gVal(2);
g3 = gVal(3);

if g1 <= 0
    Jcon1 = 0;
else
    Jcon1 = sigbound*g1;
end

if g2 <= 0
    Jcon2 = 0;
else
    Jcon2 = sigbound*g2;
end

if g3 <= 0
    Jcon3 = 0;
else
    Jcon3 = sigvel*g3;
end

J = J0 + Jcon1 + Jcon2 + Jcon3;



if nargout  > 1
    gradJ0 = (s1 - fi)'*invQ;
   
    if g1 <= 0
        gradGcon1 = [0 0 0 0];
    else
        gradGcon1 = [0 1 0 0] - (3*p3*([1 0 0 0]*s1)^2 + 2*p2*([1 0 0 0]*s1) + p1)*[1 0 0 0];
    end
    
    if g2 <= 0
        gradGcon2 = [0 0 0 0];
    else
        gradGcon2 = -([0 1 0 0] - (3*p3*([1 0 0 0]*s1)^2 + 2*p2*([1 0 0 0]*s1) + p1)*[1 0 0 0]);
    end
    

    bigQ = [zeros(2) zeros(2,2); zeros(2,2) eye(2,2)];

    if g3 <=0 
        gradGcon3 = [0 0 0 0];
    else
        gradGcon3 = 1/2 * (s1'*bigQ*s1)^(-1/2) * (2*s1'*bigQ);
    end
    

    
    gradJ1 = sigbound * gradGcon1;
    gradJ2 = sigbound * gradGcon2;
    gradJ3 = sigvel * gradGcon3;

    
    gradJ = (gradJ0 + gradJ1 + gradJ2 + gradJ3)';
    
end


end